<script setup>
import { Head, Link, router } from '@inertiajs/vue3';
import AppLayout from '@/Layouts/AppLayout.vue';
import Pagination from '@/Components/Pagination.vue';
import { ref, watch } from 'vue';

const props = defineProps({
    items: {
        type: Object,
        default: {},
    }
});

const filter = ref({
    name: route().params?.like?.name,
    vendor_code: route().params?.like?.vendor_code,
});

watch(filter, () => {
    router.get(
        route('products.index'),
        { like: filter.value },
        { preserveState: true }
    )
}, {deep: true});
</script>

<template>
    <Head title="Продукты"/>

    <AppLayout>
        <template #breadcrumb>
            Продукты / Список
        </template>

        <div v-if="$page.props.errors.productHasTransactions" class="alert alert-warning d-flex align-items-center position-absolute top-50 shadow-lg" role="alert">
            <svg xmlns="http://www.w3.org/2000/svg" class="bi bi-exclamation-triangle-fill flex-shrink-0" width="16" height="16" viewBox="0 0 16 16" role="img" aria-label="Warning:">
                <path d="M8.982 1.566a1.13 1.13 0 0 0-1.96 0L.165 13.233c-.457.778.091 1.767.98 1.767h13.713c.889 0 1.438-.99.98-1.767L8.982 1.566zM8 5c.535 0 .954.462.9.995l-.35 3.507a.552.552 0 0 1-1.1 0L7.1 5.995A.905.905 0 0 1 8 5zm.002 6a1 1 0 1 1 0 2 1 1 0 0 1 0-2z"/>
            </svg>
            <b class="px-2">
                {{ $page.props.errors.productHasTransactions[0] }}
            </b>
            <button type="button" class="btn-close" @click="delete $page.props.errors.productHasTransactions"></button>
        </div>

        <div class="d-flex flex-row py-2 gap-2">
            <Link :href="route('products.create')" class="btn btn-sm btn-success">Создать</Link>
            <div class="input-group input-group-sm">
                <input type="text" class="form-control" placeholder="Наименование" v-model="filter.name">
                <button class="btn btn-danger" type="button" @click="filter.name = ''">
                    <svg xmlns="http://www.w3.org/2000/svg" width="21" height="21" fill="currentColor" class="bi bi-x-lg" viewBox="0 0 16 16">
                        <path d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8 2.146 2.854Z"/>
                    </svg>
                </button>
            </div>
            <div class="input-group input-group-sm">
                <input type="text" class="form-control" placeholder="Артикул" v-model="filter.vendor_code">
                <button class="btn btn-danger" type="button" @click="filter.vendor_code = ''">
                    <svg xmlns="http://www.w3.org/2000/svg" width="21" height="21" fill="currentColor" class="bi bi-x-lg" viewBox="0 0 16 16">
                        <path d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8 2.146 2.854Z"/>
                    </svg>
                </button>
            </div>
        </div>

        <div class="table-responsive">
            <table class="table table-striped table-hover mb-0">
                <thead>
                    <tr>
                        <th scope="col" style="width: 1%;">#</th>
                        <th scope="col">Наименование</th>
                        <th scope="col">Артикул</th>
                        <th scope="col" style="width: 1%;"></th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item, index) in props.items?.data" :key="item.id">
                        <th scope="row" v-html="props.items?.from + index"/>
                        <td>
                            <Link :href="route('products.edit', item.id)" v-html="item.name" class="d-block"/>
                        </td>
                        <td v-html="item.vendor_code"/>
                        <td>
                            <Link as="button" method="delete" :href="route('products.destroy', item.id)" class="btn btn-sm p-0 d-flex">
                                <svg xmlns="http://www.w3.org/2000/svg" width="22" height="22" fill="currentColor" class="bi bi-x-octagon-fill text-danger" viewBox="0 0 16 16">
                                    <path d="M11.46.146A.5.5 0 0 0 11.107 0H4.893a.5.5 0 0 0-.353.146L.146 4.54A.5.5 0 0 0 0 4.893v6.214a.5.5 0 0 0 .146.353l4.394 4.394a.5.5 0 0 0 .353.146h6.214a.5.5 0 0 0 .353-.146l4.394-4.394a.5.5 0 0 0 .146-.353V4.893a.5.5 0 0 0-.146-.353L11.46.146zm-6.106 4.5L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 1 1 .708-.708z"/>
                                </svg>
                            </Link>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <Pagination :links="props.items.links" class="my-2"/>
    </AppLayout>
</template>

<style scoped>
.table-responsive {
    overflow: auto;
    height: calc(100vh - 9rem);
}
</style>
